#ifndef __X10_COMPILER_FINALIZATION_H
#define __X10_COMPILER_FINALIZATION_H

#include <x10rt.h>


#define X10_LANG_THROWABLE_H_NODEPS
#include <x10/lang/Throwable.h>
#undef X10_LANG_THROWABLE_H_NODEPS
#define X10_IO_CUSTOMSERIALIZATION_H_NODEPS
#include <x10/io/CustomSerialization.h>
#undef X10_IO_CUSTOMSERIALIZATION_H_NODEPS
#define X10_LANG_BOOLEAN_H_NODEPS
#include <x10/lang/Boolean.h>
#undef X10_LANG_BOOLEAN_H_NODEPS
namespace x10 { namespace lang { 
class Any;
} } 
namespace x10 { namespace lang { 
class String;
} } 
namespace x10 { namespace lang { 
class Boolean;
} } 
namespace x10 { namespace compiler { 
class CompilerFlags;
} } 
namespace x10 { namespace io { 
class SerialData;
} } 
namespace x10 { namespace lang { 
class UnsupportedOperationException;
} } 
namespace x10 { namespace lang { 
class Object;
} } 
namespace x10 { namespace compiler { 

class Finalization : public x10::lang::Throwable   {
    public:
    RTT_H_DECLS_CLASS
    
    static x10aux::itable_entry _itables[3];
    
    virtual x10aux::itable_entry* _getITables() { return _itables; }
    
    static x10::io::CustomSerialization::itable<x10::compiler::Finalization > _itable_0;
    
    static x10::lang::Any::itable<x10::compiler::Finalization > _itable_1;
    
    x10aux::ref<x10::lang::Any> FMGL(value);
    
    x10aux::ref<x10::lang::String> FMGL(label);
    
    x10_boolean FMGL(isReturn);
    
    x10_boolean FMGL(isBreak);
    
    x10_boolean FMGL(isContinue);
    
    static void throwReturn();
    static void throwReturn(x10aux::ref<x10::lang::Any> v);
    static void throwBreak();
    static void throwBreak(x10aux::ref<x10::lang::String> l);
    static void throwContinue();
    static void throwContinue(x10aux::ref<x10::lang::String> l);
    static void plausibleThrow();
    virtual x10aux::ref<x10::io::SerialData> serialize();
    void _constructor(x10aux::ref<x10::io::SerialData> id__93);
    
    static x10aux::ref<x10::compiler::Finalization> _make(x10aux::ref<x10::io::SerialData> id__93);
    
    void _constructor();
    
    static x10aux::ref<x10::compiler::Finalization> _make();
    
    virtual x10aux::ref<x10::compiler::Finalization> x10__compiler__Finalization____x10__compiler__Finalization__this(
      );
    void __fieldInitializers41383();
    
    // Serialization
    public: static const x10aux::serialization_id_t _serialization_id;
    
    public: virtual x10aux::serialization_id_t _get_serialization_id() {
         return _serialization_id;
    }
    
    public: virtual void _serialize_body(x10aux::serialization_buffer& buf);
    
    public: static x10aux::ref<x10::lang::Reference> _deserializer(x10aux::deserialization_buffer& buf);
    
    public: void _deserialize_body(x10aux::deserialization_buffer& buf);
    
};

} } 
#endif // X10_COMPILER_FINALIZATION_H

namespace x10 { namespace compiler { 
class Finalization;
} } 

#ifndef X10_COMPILER_FINALIZATION_H_NODEPS
#define X10_COMPILER_FINALIZATION_H_NODEPS
#ifndef X10_COMPILER_FINALIZATION_H_GENERICS
#define X10_COMPILER_FINALIZATION_H_GENERICS
#endif // X10_COMPILER_FINALIZATION_H_GENERICS
#endif // __X10_COMPILER_FINALIZATION_H_NODEPS
